ALTER TABLE `AutoRoleRules`
    MODIFY `LastModifiedAt` DATETIME(6) NULL ON UPDATE CURRENT_TIMESTAMP(6);

ALTER TABLE `AutoRoleRules`
    ALTER COLUMN `CreatedAt` SET DEFAULT CURRENT_TIMESTAMP(6);

ALTER TABLE `AutoRoleRules`
    ALTER COLUMN `LastModifiedAt` SET DEFAULT CURRENT_TIMESTAMP(6);

CREATE TABLE IF NOT EXISTS `AutoRoleRulesHistory`
(
    `AutoRoleRuleId`   BIGINT(20)  NOT NULL,
    `AutoRoleId`       BIGINT(20)  DEFAULT NULL,
    `DiscordEmojiName` VARCHAR(64) DEFAULT NULL,
    `DiscordRoleId`    BIGINT(20)  NOT NULL,
    `Deleted`          BOOL        DEFAULT FALSE,
    `DateFrom`         DATETIME(6) NOT NULL,
    `DateTo`           DATETIME(6) NOT NULL
);

DROP TRIGGER IF EXISTS `TR_AutoRoleRulesUpdate`;

CREATE TRIGGER `TR_AutoRoleRulesUpdate`
    AFTER UPDATE
    ON `AutoRoleRules`
    FOR EACH ROW
BEGIN
    INSERT INTO `AutoRoleRulesHistory` (
        `AutoRoleRuleId`, `AutoRoleId`, `DiscordEmojiName`, `DiscordRoleId`, `DateFrom`, `DateTo`
    )
    VALUES (
        OLD.AutoRoleRuleId, OLD.AutoRoleId, OLD.DiscordEmojiName, OLD.DiscordRoleId, OLD.LastModifiedAt, CURRENT_TIMESTAMP(6)
    );
END;

DROP TRIGGER IF EXISTS `TR_AutoRoleRulesDelete`;

CREATE TRIGGER `TR_AutoRoleRulesDelete`
    AFTER DELETE
    ON `AutoRoleRules`
    FOR EACH ROW
BEGIN
    INSERT INTO `AutoRoleRulesHistory` (
        `AutoRoleRuleId`, `AutoRoleId`, `DiscordEmojiName`, `DiscordRoleId`, `Deleted`, `DateFrom`, `DateTo`
    )
    VALUES (
        OLD.AutoRoleRuleId, OLD.AutoRoleId, OLD.DiscordEmojiName, OLD.DiscordRoleId, TRUE, OLD.LastModifiedAt, CURRENT_TIMESTAMP(6)
    );
END;