ALTER TABLE `AutoRoles`
    MODIFY `LastModifiedAt` DATETIME(6) NULL ON UPDATE CURRENT_TIMESTAMP(6);

ALTER TABLE `AutoRoles`
    ALTER COLUMN `CreatedAt` SET DEFAULT CURRENT_TIMESTAMP(6);

ALTER TABLE `AutoRoles`
    ALTER COLUMN `LastModifiedAt` SET DEFAULT CURRENT_TIMESTAMP(6);

CREATE TABLE IF NOT EXISTS `AutoRolesHistory`
(
    `AutoRoleId`       BIGINT(20)  NOT NULL,
    `ServerId`         BIGINT(20) DEFAULT NULL,
    `DiscordChannelId` BIGINT(20)  NOT NULL,
    `DiscordMessageId` BIGINT(20)  NOT NULL,
    `Deleted`          BOOL       DEFAULT FALSE,
    `DateFrom`         DATETIME(6) NOT NULL,
    `DateTo`           DATETIME(6) NOT NULL
);

DROP TRIGGER IF EXISTS `TR_AutoRolesUpdate`;

CREATE TRIGGER `TR_AutoRolesUpdate`
    AFTER UPDATE
    ON `AutoRoles`
    FOR EACH ROW
BEGIN
    INSERT INTO `AutoRolesHistory` (
        `AutoRoleId`, `ServerId`, `DiscordChannelId`, `DiscordMessageId`, `DateFrom`, `DateTo`
    )
    VALUES (
        OLD.AutoRoleId, OLD.ServerId, OLD.DiscordChannelId, OLD.DiscordMessageId, OLD.LastModifiedAt,
        CURRENT_TIMESTAMP(6)
    );
END;

DROP TRIGGER IF EXISTS `TR_AutoRolesDelete`;

CREATE TRIGGER `TR_AutoRolesDelete`
    AFTER DELETE
    ON `AutoRoles`
    FOR EACH ROW
BEGIN
    INSERT INTO `AutoRolesHistory` (
        `AutoRoleId`, `ServerId`, `DiscordChannelId`, `DiscordMessageId`, `Deleted`, `DateFrom`, `DateTo`
    )
    VALUES (
        OLD.AutoRoleId, OLD.ServerId, OLD.DiscordChannelId, OLD.DiscordMessageId, TRUE, OLD.LastModifiedAt,
        CURRENT_TIMESTAMP(6)
    );
END;