ALTER TABLE `KnownUsers`
    MODIFY `LastModifiedAt` DATETIME(6) NULL ON UPDATE CURRENT_TIMESTAMP(6);

ALTER TABLE `KnownUsers`
    ALTER COLUMN `CreatedAt` SET DEFAULT CURRENT_TIMESTAMP(6);

ALTER TABLE `KnownUsers`
    ALTER COLUMN `LastModifiedAt` SET DEFAULT CURRENT_TIMESTAMP(6);

CREATE TABLE IF NOT EXISTS `KnownUsersHistory`
(
    `KnownUserId` BIGINT(20)  NOT NULL,
    `DiscordId`   BIGINT(20)  NOT NULL,
    `Deleted`     BOOL DEFAULT FALSE,
    `DateFrom`    DATETIME(6) NOT NULL,
    `DateTo`      DATETIME(6) NOT NULL
);

DROP TRIGGER IF EXISTS `TR_KnownUsersUpdate`;

CREATE TRIGGER `TR_KnownUsersUpdate`
    AFTER UPDATE
    ON `KnownUsers`
    FOR EACH ROW
BEGIN
    INSERT INTO `KnownUsersHistory` (
        `KnownUserId`, `DiscordId`, `DateFrom`, `DateTo`
    )
    VALUES (
        OLD.KnownUserId, OLD.DiscordId, OLD.LastModifiedAt, CURRENT_TIMESTAMP(6)
    );
END;

DROP TRIGGER IF EXISTS `TR_KnownUsersDelete`;

CREATE TRIGGER `TR_KnownUsersDelete`
    AFTER DELETE
    ON `KnownUsers`
    FOR EACH ROW
BEGIN
    INSERT INTO `KnownUsersHistory` (
        `KnownUserId`, `DiscordId`, `Deleted`, `DateFrom`, `DateTo`
    )
    VALUES (
        OLD.KnownUserId, OLD.DiscordId, TRUE, OLD.LastModifiedAt, CURRENT_TIMESTAMP(6)
    );
END;