ALTER TABLE `Servers`
    MODIFY `LastModifiedAt` DATETIME(6) NULL ON UPDATE CURRENT_TIMESTAMP(6);

ALTER TABLE `Servers`
    ALTER COLUMN `CreatedAt` SET DEFAULT CURRENT_TIMESTAMP(6);

ALTER TABLE `Servers`
    ALTER COLUMN `LastModifiedAt` SET DEFAULT CURRENT_TIMESTAMP(6);

CREATE TABLE IF NOT EXISTS `ServersHistory`
(
    `ServerId`        BIGINT(20)  NOT NULL,
    `DiscordServerId` BIGINT(20)  NOT NULL,
    `Deleted`         BOOL DEFAULT FALSE,
    `DateFrom`        DATETIME(6) NOT NULL,
    `DateTo`          DATETIME(6) NOT NULL
);

DROP TRIGGER IF EXISTS `TR_ServersUpdate`;

CREATE TRIGGER `TR_ServersUpdate`
    AFTER UPDATE
    ON `Servers`
    FOR EACH ROW
BEGIN
    INSERT INTO `ServersHistory` (
        `ServerId`, `DiscordServerId`, `DateFrom`, `DateTo`
    )
    VALUES (
        OLD.ServerId, OLD.DiscordServerId, OLD.LastModifiedAt, CURRENT_TIMESTAMP(6)
    );
END;

DROP TRIGGER IF EXISTS `TR_ServersDelete`;

CREATE TRIGGER `TR_ServersDelete`
    AFTER DELETE
    ON `Servers`
    FOR EACH ROW
BEGIN
    INSERT INTO `ServersHistory` (
        `ServerId`, `DiscordServerId`, `Deleted`, `DateFrom`, `DateTo`
    )
    VALUES (
        OLD.ServerId, OLD.DiscordServerId, TRUE, OLD.LastModifiedAt, CURRENT_TIMESTAMP(6)
    );
END;