ALTER TABLE `UserJoinedVoiceChannel`
    MODIFY `LastModifiedAt` DATETIME(6) NULL ON UPDATE CURRENT_TIMESTAMP(6);

ALTER TABLE `UserJoinedVoiceChannel`
    ALTER COLUMN `CreatedAt` SET DEFAULT CURRENT_TIMESTAMP(6);

ALTER TABLE `UserJoinedVoiceChannel`
    ALTER COLUMN `LastModifiedAt` SET DEFAULT CURRENT_TIMESTAMP(6);

CREATE TABLE IF NOT EXISTS `UserJoinedVoiceChannelHistory`
(
    `JoinId`           BIGINT(20)  NOT NULL,
    `UserId`           BIGINT(20)  NOT NULL,
    `DiscordChannelId` BIGINT(20)  NOT NULL,
    `JoinedOn`         DATETIME(6) NOT NULL,
    `LeavedOn`         DATETIME(6) DEFAULT NULL,
    `Deleted`          BOOL        DEFAULT FALSE,
    `DateFrom`         DATETIME(6) NOT NULL,
    `DateTo`           DATETIME(6) NOT NULL
);

DROP TRIGGER IF EXISTS `TR_UserJoinedVoiceChannelUpdate`;

CREATE TRIGGER `TR_UserJoinedVoiceChannelUpdate`
    AFTER UPDATE
    ON `UserJoinedVoiceChannel`
    FOR EACH ROW
BEGIN
    INSERT INTO `UserJoinedVoiceChannelHistory` (
        `JoinId`, `UserId`, `DiscordChannelId`, `JoinedOn`, `LeavedOn`, `DateFrom`, `DateTo`
    )
    VALUES (
        OLD.JoinId, OLD.UserId, OLD.DiscordChannelId, OLD.JoinedOn, OLD.LeavedOn, OLD.LastModifiedAt,
        CURRENT_TIMESTAMP(6)
    );
END;

DROP TRIGGER IF EXISTS `TR_UserJoinedVoiceChannelDelete`;

CREATE TRIGGER `TR_UserJoinedVoiceChannelDelete`
    AFTER DELETE
    ON `UserJoinedVoiceChannel`
    FOR EACH ROW
BEGIN
    INSERT INTO `UserJoinedVoiceChannelHistory` (
        `JoinId`, `UserId`, `DiscordChannelId`, `JoinedOn`, `LeavedOn`, `Deleted`, `DateFrom`, `DateTo`
    )
    VALUES (
        OLD.JoinId, OLD.UserId, OLD.DiscordChannelId, OLD.JoinedOn, OLD.LeavedOn, TRUE, OLD.LastModifiedAt,
        CURRENT_TIMESTAMP(6)
    );
END;