ALTER TABLE `UserMessageCountPerHour`
    MODIFY `LastModifiedAt` DATETIME(6) NULL ON UPDATE CURRENT_TIMESTAMP(6);

ALTER TABLE `UserMessageCountPerHour`
    ALTER COLUMN `CreatedAt` SET DEFAULT CURRENT_TIMESTAMP(6);

ALTER TABLE `UserMessageCountPerHour`
    ALTER COLUMN `LastModifiedAt` SET DEFAULT CURRENT_TIMESTAMP(6);

CREATE TABLE IF NOT EXISTS `UserMessageCountPerHourHistory`
(
    `Id`       BIGINT(20)  NOT NULL,
    `Date`     DATETIME(6) NOT NULL,
    `Hour`     BIGINT(20) DEFAULT NULL,
    `XPCount`  BIGINT(20) DEFAULT NULL,
    `UserId`   BIGINT(20) DEFAULT NULL,
    `Deleted`  BOOL       DEFAULT FALSE,
    `DateFrom` DATETIME(6) NOT NULL,
    `DateTo`   DATETIME(6) NOT NULL
);

DROP TRIGGER IF EXISTS `TR_UserMessageCountPerHourUpdate`;

CREATE TRIGGER `TR_UserMessageCountPerHourUpdate`
    AFTER UPDATE
    ON `UserMessageCountPerHour`
    FOR EACH ROW
BEGIN
    INSERT INTO `UserMessageCountPerHourHistory` (
        `Id`, `UserId`, `Date`, `Hour`, `XPCount`, `DateFrom`, `DateTo`
    )
    VALUES (
        OLD.Id, OLD.UserId, OLD.Date, OLD.Hour, OLD.XPCount, OLD.LastModifiedAt, CURRENT_TIMESTAMP(6)
    );
END;

DROP TRIGGER IF EXISTS `TR_UserMessageCountPerHourDelete`;

CREATE TRIGGER `TR_UserMessageCountPerHourDelete`
    AFTER DELETE
    ON `UserMessageCountPerHour`
    FOR EACH ROW
BEGIN
    INSERT INTO `UserMessageCountPerHourHistory` (
        `Id`, `UserId`, `Date`, `Hour`, `XPCount`, `Deleted`, `DateFrom`, `DateTo`
    )
    VALUES (
        OLD.Id, OLD.UserId, OLD.Date, OLD.Hour, OLD.XPCount, TRUE, OLD.LastModifiedAt, CURRENT_TIMESTAMP(6)
    );
END;