ALTER TABLE `Users`
    MODIFY `LastModifiedAt` DATETIME(6) NULL ON UPDATE CURRENT_TIMESTAMP(6);

ALTER TABLE `Users`
    ALTER COLUMN `CreatedAt` SET DEFAULT CURRENT_TIMESTAMP(6);

ALTER TABLE `Users`
    ALTER COLUMN `LastModifiedAt` SET DEFAULT CURRENT_TIMESTAMP(6);

CREATE TABLE IF NOT EXISTS `UsersHistory`
(
    `UserId`    BIGINT(20)  NOT NULL,
    `DiscordId` BIGINT(20)  NOT NULL,
    `XP`        BIGINT(20)  NOT NULL DEFAULT 0,
    `ServerId`  BIGINT(20)           DEFAULT NULL,
    `Deleted`   BOOL                 DEFAULT FALSE,
    `DateFrom`  DATETIME(6) NOT NULL,
    `DateTo`    DATETIME(6) NOT NULL
);

DROP TRIGGER IF EXISTS `TR_UsersUpdate`;

CREATE TRIGGER `TR_UsersUpdate`
    AFTER UPDATE
    ON `Users`
    FOR EACH ROW
BEGIN
    INSERT INTO `UsersHistory` (
        `UserId`, `DiscordId`, `XP`, `ServerId`, `DateFrom`, `DateTo`
    )
    VALUES (
        OLD.UserId, OLD.DiscordId, OLD.XP, OLD.ServerId, OLD.LastModifiedAt, CURRENT_TIMESTAMP(6)
    );
END;

DROP TRIGGER IF EXISTS `TR_UsersDelete`;

CREATE TRIGGER `TR_UsersDelete`
    AFTER DELETE
    ON `Users`
    FOR EACH ROW
BEGIN
    INSERT INTO `UsersHistory` (
        `UserId`, `DiscordId`, `XP`, `ServerId`, `Deleted`, `DateFrom`, `DateTo`
    )
    VALUES (
        OLD.UserId, OLD.DiscordId, OLD.XP, OLD.ServerId, TRUE, OLD.LastModifiedAt, CURRENT_TIMESTAMP(6)
    );
END;